[bits 16]
org 0x7c00
push cs
pop ds
jmp over_routines

;The string print routine
print:
lodsb
cmp al, 0
je done_print
mov ah, 0x0e
int 0x10
jmp print
done_print:
ret


startmsg db 13, 10, "<porter>", 0
decision db 13, 10, "(s/r/p) : ", 0
sendport db 13, 10, "port>", 0
receiveport db 13, 10, "port>", 0
received db 13, 10, "got: ", 0
sendvalue db 13, 10, "send>", 0
regnames db 13, 10, "ax   bx   cx   dx   si   di", 13, 10, 0
regspace db " ", 0





print_nibble:
cmp al, 0x39
ja print_hex
mov ah,0x0e
int 0x10
ret
print_hex:
add al, 7
mov ah, 0x0e
int 0x10
ret

print_byte: ;in bl
mov al, bl
and al, 0xf0
shr al, 4
add al, 0x30
call print_nibble
mov al, bl
and al, 0x0f
add al, 0x30
call print_nibble
ret

print_word: ; in cx
mov bl, ch
call print_byte
mov bl, cl
call print_byte
ret








accept_nibble:
mov ax, 0
int 0x16
mov ah, 0x0e
int 0x10
sub al, 0x30
cmp al, 0x9
ja sub7
jmp nosub7
sub7:
sub al, 7
nosub7:
ret


thebyte db 0
accept_byte:
call accept_nibble
shl al, 4
mov [thebyte], al
call accept_nibble
and al, 0xf
or [thebyte], al
ret

theword dw 0
accept_word:
mov word[theword], 0
call accept_nibble
and ax, 0xf
shl ax, 12
or [theword], ax
call accept_nibble
and ax, 0xf
shl ax, 8
or [theword], ax
call accept_nibble
and ax, 0xf
shl ax, 4
or [theword], ax
call accept_nibble
and ax, 0xf
or [theword], ax
ret




receive:
mov si, receiveport
call print
call accept_word
mov dx, [theword]
mov si, received
call print
in al, dx
mov bl,al
call print_byte
ret

send:
mov si, sendport
call print
call accept_word
mov dx, [theword]
mov si, sendvalue
call print
call accept_byte
mov al, [thebyte]
out dx, al
ret



print_regs:
mov [0x1000], ax
mov [0x1002], bx
mov [0x1004], cx
mov [0x1006], dx
mov [0x1008], si
mov [0x100a], di
mov si, regnames
call print
mov cx, [0x1000]
call print_word
mov si, regspace
call print
mov cx, [0x1002]
call print_word
mov si, regspace
call print
mov cx, [0x1004]
call print_word
mov si, regspace
call print
mov cx, [0x1006]
call print_word
mov si, regspace
call print
mov cx, [0x1008]
call print_word
mov si, regspace
call print
mov cx, [0x100a]
call print_word
mov si, regspace
call print
ret




over_routines:
mov si, startmsg
call print


begin:
mov si, decision
call print

mov ax, 0
int 0x16

cmp al, 'r'
jne not_r
call receive
not_r:
cmp al, 's'
jne not_s
call send
not_s:
cmp al, 'p'
jne not_p
call print_regs
not_p:

jmp begin




times 510 - ($-$$) db 0
dw 0xaa55
